<template>
	<header class="app-header">
		<nav>
			<h1>Nearby Wiki Articles</h1>
		</nav>
	</header>	

	<main class="app-main">
		<div v-if="articles" class="app-results">
			<p>Showing results for coordinates: {{  coordinates }}</p>

			<ul v-if="articles.length > 0">
				<li v-for="article in articles">
					<cdx-card 
						:url="article.canonicalurl"
						:thumbnail="article.thumbnail ? getThumbnailData( article ) : null"
						:force-thumbnail="true"
					>
						<template #title>
							{{ article.title }}
						</template>
						<template #description>
							{{ article.description }}
						</template>
					</cdx-card>
				</li>
			</ul>

			<p v-else>
				Sorry, no nearby articles found.
			</p>

			<p>
				<cdx-button 
					class="btn-clear"
					action="destructive"
					@click="resetArticles" 
				>
					Clear current results
				</cdx-button>
			</p>
		</div>

		<div v-else>
			<p>
				<cdx-button 
					class="btn-nearby"
					action="progressive" 
					type="primary"
					@click="showNearbyArticles" 
				>
					<cdx-icon :icon="cdxIconMapPin" size="small" />
					Show nearby articles
				</cdx-button>
			</p>

			<p>
				<cdx-button 
					class="btn-random"
					action="progressive"
					@click="showRandomArticles" 
				>
					<cdx-icon :icon="cdxIconDie" size="small" />
					Show random articles
				</cdx-button>
			</p>

		</div>
	</main>
</template>

<script>
import { defineComponent } from 'vue';
import { CdxButton, CdxIcon, CdxCard } from '@wikimedia/codex';
import { cdxIconMapPin, cdxIconDie, cdxIconArticle } from '@wikimedia/codex-icons';

/**
 * Get a random number between two values with a specified number of decimpal places.
 * 
 * @param {number} min 
 * @param {number} max 
 * @param {number} fixed
 */
function getRandomInRange( min, max, fixed ) {
	return ( Math.random() * ( max - min ) + min ).toFixed( fixed );
}

export default defineComponent( {
	components: {
		CdxButton,
		CdxIcon,
		CdxCard
	},

	data() {
		return {
			articles: null, 
			coordinates: null,
			cdxIconDie,
			cdxIconMapPin,
			cdxIconArticle
		};
	},

	methods: {
		/**
		 * Get a list of articles based on the user's geolocation (if they allow it)
		 */
		showNearbyArticles() {
			navigator.geolocation.getCurrentPosition( 
				success => {
					this.fetchArticlesByGeolocation( success.coords.latitude, success.coords.longitude );
				},
				error => {
					console.log( error );
				}
			)
		},

		/**
		 * Get a list of articles based on a random geolocation
		 */
		showRandomArticles() {
			this.fetchArticlesByGeolocation();
		},

		/**
		 * Get thumbnail data for a particular article in the results
		 *
		 * @param {Object} article 
		 */
		getThumbnailData( article ) {
			return {
				width: article.thumbnail.width,
				height: article.thumbnail.height,
				url: article.thumbnail.source
			}
		},

		/**
		 * Get a list of articles based on coordinates.
		 * Returns a promise in case to allow for chaining if needed.
		 *
		 * @param {string} lat 
		 * @param {string} lng 
		 * @return {Promise}
		 */
		fetchArticlesByGeolocation( lat = getRandomInRange( -90, 90, 15 ), lng = getRandomInRange( -180, 180, 15 ) ) {
			const base = 'https://en.wikipedia.org/w/api.php';
			const params = {
				action: 'query',
				format: 'json',
				origin: '*',
				formatversion: 2,
				prop: 'coordinates|pageprops|pageimages|description|info|pageterms',
				inprop: 'url',
				colimit: 'max',
				generator: 'geosearch',
				ggsradius: 10000,
				ggsnamespace: 0,
				ggslimit: 25,
				redirects: 'no',
				uselang: 'en',
				ppprop: 'displaytitle',
				piprop: 'thumbnail',
				pithumbsize: 150,
				pilimit: 50,
				codistancefrompoint: `${lat}|${lng}`,
				ggscoord: `${lat}|${lng}`
			};
			
			const apiUrl = new URL( base );
			apiUrl.search = new URLSearchParams( params );

			return fetch( apiUrl )
				.then( response => response.json() )
				.then( data => {
					if ( data && data.query && data.query.pages ) {
						return data.query.pages
					} else {
						return [];
					}
				} )
				.then( pages => {
					this.articles = pages; 
					this.coordinates = `${lat}, ${lng}`;
				} );
		},

		/**
		 * Clear the article data
		 */
		resetArticles() {
			this.articles = null;
		}
	}
} );
</script>

<style>
html, body {
	font-family: var( --font-family-base );
}

.app-header {
	background-color: var( --background-color-base );
	display: flex;
	align-items: center;
	justify-content: center;
	padding: var( --spacing-25 ) var( --spacing-75 );
	margin-top: var( --spacing-100 );
	position: sticky;
	top: 0px;
}

.app-header h1 {
	margin: 0;
}

.app-main {
	display: flex;
	flex-direction: column;
	align-items: stretch;
	justify-content: center;
	padding: var( --spacing-25 ) var( --spacing-75 );
	text-align: center;
}

.app-results ul {
	text-align: left;
	list-style-type: none;
	padding-left: 0;
}

.btn-nearby,
.btn-random,
.btn-clear {
	width: var( --size-full );
}

</style>